summaryrefslogtreecommitdiffstats
path: root/source/n/dhcpcd
diff options
context:
space:
mode:
Diffstat (limited to 'source/n/dhcpcd')
-rw-r--r--source/n/dhcpcd/50-ntp.conf.diff19
-rwxr-xr-xsource/n/dhcpcd/dhcpcd.SlackBuild101
-rw-r--r--source/n/dhcpcd/dhcpcd.vararg.diff30
-rw-r--r--source/n/dhcpcd/doinst.sh15
-rw-r--r--source/n/dhcpcd/patches/config.h.diff17
-rw-r--r--source/n/dhcpcd/patches/dhcpcd.8.in.diff12
-rw-r--r--source/n/dhcpcd/patches/dhcpcd.sh.diff17
7 files changed, 85 insertions, 126 deletions
diff --git a/source/n/dhcpcd/50-ntp.conf.diff b/source/n/dhcpcd/50-ntp.conf.diff
new file mode 100644
index 000000000..d86c299e2
--- /dev/null
+++ b/source/n/dhcpcd/50-ntp.conf.diff
@@ -0,0 +1,19 @@
+diff -Nur dhcpcd-5.1.0.orig/dhcpcd-hooks/50-ntp.conf dhcpcd-5.1.0/dhcpcd-hooks/50-ntp.conf
+--- dhcpcd-5.1.0.orig/dhcpcd-hooks/50-ntp.conf 2009-09-02 15:21:11.000000000 -0500
++++ dhcpcd-5.1.0/dhcpcd-hooks/50-ntp.conf 2009-09-12 00:36:04.447859980 -0500
+@@ -8,14 +8,8 @@
+ # NTP_CONF=/usr/pkg/etc/ntpd.conf
+ # to use openntpd from pkgsrc instead of the system provided ntp.
+
+-# Detect OpenRC or BSD rc
+-# Distributions may want to just have their command here instead of this
+-if type rc-service >/dev/null 2>&1 && rc-service --exists ntpd; then
+- ntpd_restart_cmd="rc-service ntpd -- -Ds restart"
+-elif [ -x /etc/rc.d/ntpd ]; then
++if [ -x /etc/rc.d/ntpd ]; then
+ ntpd_restart_cmd="/etc/rc.d/ntpd status >/dev/null 2>&1 && /etc/rc.d/ntpd restart"
+-elif [ -x /usr/local/etc/rc.d/ntpd ]; then
+- ntpd_restart_cmd="/usr/local/etc/rc.d/ntpd status >/dev/null 2>&1 && /usr/local/etc/rc.d/ntpd restart"
+ fi
+
+ ntp_conf_dir="$state_dir/ntp.conf"
diff --git a/source/n/dhcpcd/dhcpcd.SlackBuild b/source/n/dhcpcd/dhcpcd.SlackBuild
index 409118746..3ee95a902 100755
--- a/source/n/dhcpcd/dhcpcd.SlackBuild
+++ b/source/n/dhcpcd/dhcpcd.SlackBuild
@@ -1,6 +1,6 @@
#!/bin/sh
-# Copyright 2008, 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# Copyright 2008, 2009, 2010 Patrick J. Volkerding, Sebeka, MN, USA
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
@@ -21,27 +21,44 @@
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-VERSION=${VERSION:-3.2.3}
-ARCH=${ARCH:-x86_64}
+VERSION=${VERSION:-$(echo dhcpcd-*.tar.?z* | rev | cut -f 3- -d . | cut -f 1 -d - | rev)}
BUILD=${BUILD:-1}
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
+fi
+
CWD=$(pwd)
TMP=${TMP:-/tmp}
PKG=$TMP/package-dhcpcd
if [ "$ARCH" = "i486" ]; then
SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
elif [ "$ARCH" = "s390" ]; then
SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
fi
rm -rf $PKG
mkdir -p $TMP $PKG
cd $TMP
rm -rf dhcpcd-$VERSION
-tar xvf $CWD/dhcpcd-$VERSION.tar.bz2 || exit 1
+tar xvf $CWD/dhcpcd-$VERSION.tar.?z* || exit 1
cd dhcpcd-$VERSION
chown -R root:root .
find . \
@@ -50,65 +67,49 @@ find . \
\( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
-exec chmod 644 {} \;
-# This changes the default locations where *.pid and other files are
-# written - instead of various locations, use /etc/dhcpc
-# The latter directory was long traditional, and (more importantly)
-# you can't be sure that /var is mounted yet when dhcpcd is invoked.
-zcat $CWD/patches/config.h.diff.gz | patch -p1 || exit 1
-
-# Fixup the sample dhcpcd.sh script to reflect our changes
-zcat $CWD/patches/dhcpcd.sh.diff.gz | patch -p1 || exit 1
+# At this point, it should be safe to assume that /var will be mounted by the
+# time dhcpcd is called, as all non-root local filesystems are mounted from
+# /etc/rc.d/rc.S, and /var should not be on a network filesystem. As such,
+# we'll use the FHS layout instead of putting things in /etc/dhcpc
-# Fix a typo in the manpage
-zcat $CWD/patches/dhcpcd.8.in.diff.gz | patch -p1 || exit 1
-
-# Disable zeroconf support
-# I'm not sure if this is necessary, to be honest. If we do this though,
-# I think we'll want to edit the man page to remove references to it.
-#sed -i 's%#define ENABLE_IPV4LL%#undef ENABLE_IPV4LL%' config.h
-
-# Fix segfaulting on x86_64. Apparently i?86 is more forgiving
-#zcat $CWD/dhcpcd.vararg.diff.gz | patch -p1 --verbose || exit 1
+# Fixup the 50-ntp.conf hook with our init script location
+zcat $CWD/50-ntp.conf.diff.gz | patch -p1 || exit 1
+# Yes, /lib/dhcpcd is correct, even on x86_64.
CFLAGS="$SLKCFLAGS" \
- make INFODIR=/etc/dhcpc || exit 1
-
-# We'll install this manually, as the only thing "make install" actually
-# installs is the executable and the man page, and the man page goes to
-# the wrong place :-)
-mkdir -p $PKG/sbin
-cp -a dhcpcd $PKG/sbin
-
-mkdir -p $PKG/usr/man/man8
-gzip -9c dhcpcd.8 > $PKG/usr/man/man8/dhcpcd.8.gz
-
-# This script (or its equivalent) has been installed non-executable for
-# several dhcpcd releases leading me to believe this is intentional on the
-# part of the developers. Indeed, the script is called a "sample" in the
-# included comments, and there's been at least one security issue related
-# to its use in the past, so it's probably a safer bet to not install it so
-# that it works "out of the box". However, making it non-executable is not
-# the best solution for this as it leads to error messages in the system
-# logs which I hear about from time to time. Instead, we'll make it
-# executable, but will give it a suffix of -sample so that dhcpcd won't
-# attempt to run it unless the admin specifically configure it to do so.
-# As far as I can tell it does nothing more than add some extra verbosity
-# to the logs anyway, and rc.inet1 already does that. There's really no
-# need that I can see to enable the script.
-mkdir -p $PKG/etc/dhcpc
-cp -a dhcpcd.sh $PKG/etc/dhcpc/dhcpcd.sh-sample
-chmod 755 $PKG/etc/dhcpc/dhcpcd.sh-sample
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sbindir=/sbin \
+ --sysconfdir=/etc \
+ --dbdir=/var/lib/dhcpcd \
+ --libexecdir=/lib/dhcpcd \
+ --mandir=/usr/man \
+ --with-hooks="50-ntp.conf 50-yp.conf" \
+ --build=$ARCH-slackware-linux
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG HOOKSCRIPTS="50-ntp.conf 50-yp.conf" || exit 1
find $PKG | xargs file | grep -e "executable" -e "shared object" \
| grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+# Let's not clobber the config file
+mv $PKG/etc/dhcpcd.conf $PKG/etc/dhcpcd.conf.new
+
+# Compress manpages
+( cd $PKG/usr/man
+ find . -type f -exec gzip -9 {} \;
+ for i in $(find . -type l) ; do ln -s $(readlink $i).gz $i.gz ; rm $i ; done
+)
+
mkdir -p $PKG/usr/doc/dhcpcd-$VERSION
cp -a README $PKG/usr/doc/dhcpcd-$VERSION
zcat $CWD/COPYRIGHT.gz > $PKG/usr/doc/dhcpcd-$VERSION/COPYRIGHT
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
+zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
cd $PKG
/sbin/makepkg -l y -c n $TMP/dhcpcd-$VERSION-$ARCH-$BUILD.txz
-
diff --git a/source/n/dhcpcd/dhcpcd.vararg.diff b/source/n/dhcpcd/dhcpcd.vararg.diff
deleted file mode 100644
index b3ac81ca5..000000000
--- a/source/n/dhcpcd/dhcpcd.vararg.diff
+++ /dev/null
@@ -1,30 +0,0 @@
---- dhcpcd-2.0.8.orig/src/logger.c 2008-11-07 00:10:23.000000000 +0000
-+++ dhcpcd-2.0.8/src/logger.c 2008-11-07 00:13:46.000000000 +0000
-@@ -46,21 +46,25 @@
- {
- va_list p;
- va_list p2;
-+ va_list p3;
- FILE *f = stderr;
-
- va_start(p, fmt);
- va_copy(p2, p);
-+ va_copy(p3, p);
- /* The default to send debug to stderr is just WAY too much console noise, IMHO */
- if(!Daemonized && strcmp(syslog_level_msg[level],"Info")) {
- f = stdout;
- /* fprintf(f, "%s, ", syslog_level_msg[level]); */
- vfprintf(f, fmt, p);
- fputc('\n', f);
-- vsyslog(level, fmt, p);
-+ vsyslog(level, fmt, p2);
- }
- if ( level <= LogLevel )
-- vsyslog(level, fmt, p2);
-+ vsyslog(level, fmt, p3);
- va_end(p);
-+ va_end(p2);
-+ va_end(p3);
- }
-
- // vim: set ts=4 :
diff --git a/source/n/dhcpcd/doinst.sh b/source/n/dhcpcd/doinst.sh
new file mode 100644
index 000000000..a1a93b209
--- /dev/null
+++ b/source/n/dhcpcd/doinst.sh
@@ -0,0 +1,15 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+config etc/dhcpcd.conf.new
+
diff --git a/source/n/dhcpcd/patches/config.h.diff b/source/n/dhcpcd/patches/config.h.diff
deleted file mode 100644
index 7bdefb600..000000000
--- a/source/n/dhcpcd/patches/config.h.diff
+++ /dev/null
@@ -1,17 +0,0 @@
-diff -Nur dhcpcd-3.2.3.orig/config.h dhcpcd-3.2.3/config.h
---- dhcpcd-3.2.3.orig/config.h 2008-02-25 02:28:19.000000000 -0600
-+++ dhcpcd-3.2.3/config.h 2009-03-06 14:55:01.998436374 -0600
-@@ -71,10 +71,10 @@
-
- #define OPENNTPFILE ETCDIR "/ntpd.conf"
-
--#define DEFAULT_SCRIPT ETCDIR "/" PACKAGE ".sh"
-+#define DEFAULT_SCRIPT INFODIR "/" PACKAGE ".sh"
-
--#define STATEDIR "/var"
--#define PIDFILE STATEDIR "/run/" PACKAGE "-%s.pid"
-+#define STATEDIR INFODIR
-+#define PIDFILE INFODIR "/" PACKAGE "-%s.pid"
-
- #ifndef INFODIR
- # define INFODIR "/var/lib/dhcpcd"
diff --git a/source/n/dhcpcd/patches/dhcpcd.8.in.diff b/source/n/dhcpcd/patches/dhcpcd.8.in.diff
deleted file mode 100644
index 7486c769a..000000000
--- a/source/n/dhcpcd/patches/dhcpcd.8.in.diff
+++ /dev/null
@@ -1,12 +0,0 @@
-diff -Nur dhcpcd-3.2.3.orig/dhcpcd.8.in dhcpcd-3.2.3/dhcpcd.8.in
---- dhcpcd-3.2.3.orig/dhcpcd.8.in 2008-02-25 02:28:19.000000000 -0600
-+++ dhcpcd-3.2.3/dhcpcd.8.in 2009-03-06 19:36:02.207109931 -0600
-@@ -117,7 +117,7 @@
- up, down or new depending on the state of
- .Nm .
- .Nm
--ignores the exist code of the script.
-+ignores the exit code of the script.
- .Ss Fine tuning
- You can fine tune the behaviour of
- .Nm
diff --git a/source/n/dhcpcd/patches/dhcpcd.sh.diff b/source/n/dhcpcd/patches/dhcpcd.sh.diff
deleted file mode 100644
index 290665a98..000000000
--- a/source/n/dhcpcd/patches/dhcpcd.sh.diff
+++ /dev/null
@@ -1,17 +0,0 @@
---- a/dhcpcd.sh 2009-03-06 19:22:41.247171672 -0600
-+++ b/dhcpcd.sh 2009-03-06 19:24:19.186014526 -0600
-@@ -1,10 +1,10 @@
- #!/bin/sh
- #
--# This is a sample /etc/dhcpcd.sh script.
--# /etc/dhcpcd.sh script is executed by dhcpcd daemon
-+# This is a sample /etc/dhcpc/dhcpcd.sh script.
-+# /etc/dhcpc/dhcpcd.sh script is executed by dhcpcd daemon
- # any time it configures or shuts down interface.
--# The following parameters are passed to dhcpcd.exe script:
--# $1 = HostInfoFilePath, e.g "/var/lib/dhcpcd/dhcpcd-eth0.info"
-+# The following parameters are passed to the dhcpcd.sh script:
-+# $1 = HostInfoFilePath, e.g "/etc/dhcpc/dhcpcd-eth0.info"
- # $2 = "up" if interface has been configured with the same
- # IP address as before reboot;
- # $2 = "down" if interface has been shut down;